local TOCNAME,BOM=...
local L = setmetatable({}, {__index = function (t, k)  
	if BOM.L and BOM.L[k] then 
		return BOM.L[k]
	else
		return "["..k.."]"
	end	
end})

local locales={
	deDE ={
		MsgBuffSingle="%s %s",
		MsgBuffGroup="Gruppe %s %s",
		MsgNextCast="%s @ %s",
		MsgNoSpell="Außer Reichweite oder kein Mana",
		MsgDead="Gestorben",
		MsgCasting="zaubert",
		MsgCombat="Kampf",
		MsgEmpty="Nichts zu tun",
		
		Cboxshowminimapbutton="Minimap-Icon anzeigen",
		CboxLockMinimapButton="Minimap-Icon-Position sperren",		
		CboxLockMinimapButtonDistance="Minimap-Icon-Entfernung minimieren",
		CboxAutoOpen="Automatisches öffnen/schließen",
		CboxDeathBlock="Nicht buffen, wenn jemand tot ist",
		CboxIgnoreClass="Ignoriere Ziel-Klasse",
		CboxNoGroupBuff="Kein Gruppenbuff benutzen",
		CboxOnlySelf="Nur selbst buffen",
		
		BtnOpen="Öffnen",
		BtnCancel="Abbruch",
		BtnSettings="Einstellungen",
		
		PanelSupportedSpells="Unterstützte Zauber",
		Header_TRACKING="Suche",
		HeaderIgnoreGroup="In Raid Gruppe ignorieren",
		
		SlashSpellBook="Zauberbuch neu einlesen",
		SlashUpdate="Update Macro / Liste",
		SlashClose="BOM-Fenster schließen",
		SlashReset="BOM-Fenster zurücksetzen",
		SlashOpen="BOM-Fenster öffnen",
		
		AboutCredits="wellcat für die chinesische Übersetzung"
				
	},
	enEN ={ --EN is Master/Fallback
		MsgBuffSingle="%s %s",
		MsgBuffGroup="Group %s %s",
		MsgNextCast="%s @ %s",
		MsgNoSpell="Out of Range or Mana",
		MsgDead="Dead",
		MsgCasting="Casting",
		MsgCombat="Combat",
		MsgEmpty="Nothing to do",
	
		Cboxshowminimapbutton="Show minimap button",
		CboxLockMinimapButton="Lock minimap button position",		
		CboxLockMinimapButtonDistance="Minimize minimap button distance",
		CboxAutoOpen="Automatic open/close",
		CboxDeathBlock="Don't cast if somebody is dead",
		CboxIgnoreClass="Cast spell on every class",
		CboxNoGroupBuff="Don't use group buff",
		CboxOnlySelf="Only buff self",
				
		BtnOpen="Open",
		BtnCancel="Cancel",
		BtnSettings="Settings",
		
		Header_TRACKING="Tracking",
		PanelSupportedSpells="Supported Spells",
		HeaderIgnoreGroup="Ignore in raid group",
		
		SlashSpellBook="Rescan spellbook",
		SlashUpdate="Update macro / list",
		SlashClose="Close BOM window",
		SlashReset="Reset BOM window",
		SlashOpen="Open BOM window",
		
		AboutCredits="wellcat for the Chinese translation"
		
	},
	
	zhCN ={ 
		MsgBuffSingle="%s %s", 
		MsgBuffGroup="队伍 %s %s", 
		MsgNextCast="%s @ %s", 
		MsgNoSpell="超出距离或缺蓝", 
		MsgDead="死亡", 
		MsgCasting="施法中", 
		MsgCombat="战斗", 
		MsgEmpty="无", 
		
		Cboxshowminimapbutton="显示小地图按钮", 
		CboxLockMinimapButton="锁定小地图按钮位置", 
		CboxLockMinimapButtonDistance="最小化最小地图按钮距离", 
		CboxAutoOpen="自动 打开/关闭", 
		CboxDeathBlock="忽略死亡玩家", 
		CboxIgnoreClass="为全职业施放法术", 
		
		BtnOpen="打开", 
		BtnCancel="取消", 
		BtnSettings="设置", 
		
		Header_TRACKING="跟踪", 
		PanelSupportedSpells="支持的法术", 
		
		SlashSpellBook="重新扫描法术书", 
		SlashUpdate="更新宏/列表", 
		SlashClose="关闭插件窗口", 
		SlashReset="重置插件窗口", 
		SlashOpen="打开插件窗口", 
	},
	
	
}
if GetLocale()~="enEN" then
	BOM.L = locales[GetLocale()] or {}
	setmetatable(BOM.L, {
		__index = locales["enEN"]
	})
else
	BOM.L = locales["enEN"]
end
